<?php

/*
 * Autor: Ernesto Ruge
 * Version: 0.1
 * Lizenz: GPL
 */
?>
<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8">
    <title>WordPress Dateirechte Check</title>
    <style type="text/css">
      body {
        font-family: Arial;
      }
      .error {
        color: #990000;
      }
      
      .success {
        color: #0E7924;
      }
    </style>
  </head>

  <body>
    <h1>WordPress Dateirechte Check</h1>
    <p>Dieses Script testet, ob alle Dateirechte korrekt gesetzt sind. Das bedeutet: Schreibrechte nur dort, wo sie unbedingt nötig sind, d.h. im Upload- und ggf. im Cache-Ordner. Weitergehende Informationen (d.h. die Frage zu dem warum und wieso) erhälst du <a href="http://sectio-aurea.org/2014/07/dateirechte-warum-eigentlich/">in dem Blog-Artikel über Dateirechte.</a></p>
    <p>Für Bug-Reports und Hilfe schaue <a href="http://sectio-aurea.org">auf meiner Website vorbei</a> oder <a href="mailto:mail@ernestoruge.de">sende eine E-Mail</a>.</p>
    <h2>Core-Dateien</h2>
    <?php
      $test_file = @fopen("chmod-test-file", "a+");
      if ($test_file)
        echo("<p class=\"error\">Core-Dateien im Basisordner sind beschreibbar! Das solltest Du ändern.</p>");
      else
        echo("<p class=\"success\">Core-Dateien im Basisordner sind nicht beschreibbar. Gut!</p>");
      @fclose($test_file);
      @unlink("chmod-test-file");
      $test_file = @fopen("wp-admin/chmod-test-file", "a+");
      if ($test_file)
        echo("<p class=\"error\">Core-Dateien im Ordner wp-admin sind beschreibbar! Das solltest Du ändern.</p>");
      else
        echo("<p class=\"success\">Core-Dateien im Ordner wp-admin sind nicht beschreibbar. Gut!</p>");
      @fclose($test_file);
      @unlink("wp-admin/chmod-test-file");
      $test_file = @fopen("wp-includes/chmod-test-file", "a+");
      if ($test_file)
        echo("<p class=\"error\">Core-Dateien im Ordner wp-includes sind beschreibbar! Das solltest Du ändern.</p>");
      else
        echo("<p class=\"success\">Core-Dateien im Ordner wp-includes sind nicht beschreibbar. Gut!</p>");
      @fclose($test_file);
      @unlink("wp-includes/chmod-test-file");
    ?>
    <h2>Themes und Plugins</h2>
    <?php
      $test_file = @fopen("wp-content/chmod-test-file", "a+");
      if ($test_file)
        echo("<p class=\"error\">Der Ordner wp-content ist beschreibbar! Das solltest Du ändern.</p>");
      else
        echo("<p class=\"success\">Der Ordner wp-content ist nicht beschreibbar. Gut!</p>");
      @fclose($test_file);
      @unlink("wp-content/chmod-test-file");
      $test_file = @fopen("wp-content/plugins/chmod-test-file", "a+");
      if ($test_file)
        echo("<p class=\"error\">Der Plugin-Ordner wp-content/plugins beschreibbar! Das solltest Du ändern.</p>");
      else
        echo("<p class=\"success\">Der Plugin-Ordner wp-content/plugins ist nicht beschreibbar. Gut!</p>");
      @fclose($test_file);
      @unlink("wp-content/plugins/chmod-test-file");
      $test_file = @fopen("wp-content/themes/chmod-test-file", "a+");
      if ($test_file)
        echo("<p class=\"error\">Der Theme-Ordner wp-content/themes beschreibbar! Das solltest Du ändern.</p>");
      else
        echo("<p class=\"success\">Der Theme-Ordner wp-content/themes ist nicht beschreibbar. Gut!</p>");
      @fclose($test_file);
      @unlink("wp-content/themes/chmod-test-file");
    ?>
    <h2>.htaccess und wp-config.php</h2>
    <?php
      $test_file = @fopen(".htaccess", "a+");
      if ($test_file)
        echo("<p class=\"error\">.htaccess ist beschreibbar! Das solltest Du ändern.</p>");
      else
        echo("<p class=\"success\">.htaccess ist nicht beschreibbar. Gut!</p>");
      @fclose($test_file);
      $test_file = @fopen("wp-config.php", "a+");
      if ($test_file)
        echo("<p class=\"error\">wp-config.php ist beschreibbar! Das solltest Du ändern.</p>");
      else
        echo("<p class=\"success\">wp-config.php ist nicht beschreibbar. Gut!</p>");
      @fclose($test_file);
    ?>
    <h2>Upload-Ordner (wp-content/uploads)</h2>
    <p>Dieser Ordner muss Schreibrechte haben, damit Du etwas hochladen kannst.</p>
    <?php
      $test_file = @fopen("wp-content/uploads/chmod-test-file", "a+");
      if ($test_file)
        echo("<p class=\"success\">Upload-Ordner ist beschreibbar! Damit sind Uploads möglich.</p>");
      else
        echo("<p class=\"error\">Upload-Ordner ist nicht beschreibbar. Das solltest du ändern, sonst kannst Du nichts hochladen!</p>");
      @fclose($test_file);
      @unlink("wp-content/uploads/chmod-test-file");
    ?>
    <h2>Cache-Ordner (wp-content/cache)</h2>
    <p>Dieser Ordner muss Schreibrechte haben, damit der Cache korrekt funktioniert.</p>
    <?php
      if (file_exists("wp-content/cache/")) {
        $test_file = @fopen("wp-content/cache/chmod-test-file", "a+");
        if ($test_file)
          echo("<p class=\"success\">Cache-Ordner ist beschreibbar! Damit kann der Cache funktionieren.</p>");
        else
          echo("<p class=\"error\">Cache-Ordner ist nicht beschreibbar. Das solltest du ändern!</p>");
        @fclose($test_file);
        @unlink("wp-content/cache/chmod-test-file");
      }
      else
        echo("<p class=\"success\">Cache Ordner existiert nicht.</p>");
    ?>
    <h2>Tests abgeschlossen!</h2>
    <p>Dieser Test wurde dir bereitgestellt von <a href="http://sectio-aurea.org">sectio-aurea.org</a>.</p>
  </body>
</html>